import java.util.Map;
import java.util.TreeMap;

public class MapDemo {
    
    public static void main(String[] args) {

       Map<Person, Double> people = new TreeMap<>();
       
       Person honza = new Person("Honza");
       Person honza1 = new Person("Honza");
       Person petr = new Person("Petr");
       Person ales = new Person("Aleš");
 
       people.put(honza, 12000.0);
       people.put(honza1, 20000.0);
       people.put(petr, 3000.0);
       people.put(ales, 300000.0);

       for(Map.Entry<Person, Double> p: people.entrySet()) {
           Person person = p.getKey();
           Double salary = p.getValue();
           System.out.println(person.getName() + " has salary "+salary);
       }
      
       //System.out.println("Honza has salary="
       // +people.get(new Person("Honza")));
    }
}
class Person implements Comparable<Person> {
    
    private String name;
    public Person(String name) { this.name = name; }
    public String getName() { return name; }
    public void setName(String name) { this.name = name; } 
    
    public boolean equals(Object o) {
        if(o instanceof Person) {
            Person p = (Person)o;
            return this.name.equals(p.name);
        } else return false;
    }
    
    public int hashCode() {
        return name.hashCode();
    }
    
    public int compareTo(Person p) {
        return this.name.compareTo(p.name);
    }
}